function [AdT]=Adjoint(T)
%function [AdT]=Adjoint(T)
%take T of SE(3) and return 6x6 adjoint representation

[m,n]=size(T);
if m~=4 || n~=4
    display('Input is not a 4x4 matrix')
else
    R=[T(1,1) T(1,2) T(1,3); T(2,1) T(2,2) T(2,3); T(3,1) T(3,2) T(3,3)];
    p=[T(1,4); T(2,4); T(3,4)];
    pskew=[0 -p(3) p(2); p(3) 0 -p(1); -p(2) p(1) 0];
    AdT=[R zeros(3); pskew*R R];
end
end
