function [S,theta]=AxisAng6(Stheta)
%takes 6-vector of exponential coordinates for rigid body motion, Stheta,
%and return screw axis S and distance traveled along/about screw axis,
%theta

[m,n]=size(Stheta);
w=[Stheta(1); Stheta(2); Stheta(3)];
v=[Stheta(4); Stheta(5); Stheta(6)];
if m~=6 || n~=1
    display('Input is not a 6-vector')
elseif norm(w)==0
    theta=norm(v);
    S=Stheta/theta;
end
end
