function [T]=FKinFixed(M,Si,thetai)
%takes M in SE(3) representing the position and orientation of end-effector
%frame at home position, a list of screw axes for n joints of the robot in
%fixed world frame, and list of joint coordinates -> returns T in SE(3)
%representing the end-effector frame when joints are at the angle specified

[m,r]=size(M);
[o,p]=size(Si);
[q,s]=size(thetai);
if m~=4 || r~=4 || M(4,1)~=0 || M(4,2)~=0 || M(4,3)~=0 || M(4,4)~=1
    display('M is not a 4x4 matrix representing the position and orientation of the end effector')
else
    if o~=6 || p~=s || q~=1
        display('Third and fourth inputs are not lists of screw axes and joint coordinates and/or do not agree')
    else
            for i=1:length(Si(1,:))
                S{i}=[0 -Si(3,i) Si(2,i) Si(4,i); Si(3,i) 0 -Si(1,i) Si(5,i); -Si(2,i) Si(1,i) 0 Si(6,i); 0 0 0 1];
            end
            v=[Si(4,1); Si(5,1); Si(6,1)];
            I=eye(3);
            w=[0 -Si(3,1) Si(2,1); Si(3,1) 0 -Si(1,1); -Si(2,1) Si(1,1) 0];
            Ttemp=[I+sin(thetai(1))*w+(1-cos(thetai(1)))*w^2 (I*thetai(1)+(1-cos(thetai(1)))*w+(thetai(1)-sin(thetai(1)))*w^2)*v; 0 0 0 1];
            for i=2:length(Si(2,:))
                    v=[Si(4,i); Si(5,i); Si(6,i)];
                    w=[0 -Si(3,i) Si(2,i); Si(3,i) 0 -Si(1,i); -Si(2,i) Si(1,i) 0];
                    TT=[I+sin(thetai(i))*w+(1-cos(thetai(i)))*w^2 (I*thetai(i)+(1-cos(thetai(i)))*w+(thetai(i)-sin(thetai(i)))*w^2)*v; 0 0 0 1];
               Ttemp=Ttemp*TT;
            end
            T=Ttemp*M;
        end
end
end