function [R]=MatrixExp3(r)
%function [R]=MatrixExp3(r)
%takes 3 vector of expontential coordinates and returns R in SO(3) that is
%achieved by rotating about w by theta from an intial orientation R=I

[m,n]=size(r);
if m~=3 || n~=1
    display('Input is not a 3x1 vector')
else
    theta=norm(r);
    wa=r/theta;
    w=[0 -wa(3) wa(2); wa(3) 0 -wa(1); -wa(2) wa(1) 0];
    R=eye(3)+sin(theta).*w+(1-cos(theta))*w.^2;
end
end
