function [T]=MatrixExp6(S,theta)
%takes 6-vector of exponential coordinates Stheta and returns T in SE(3)
%that is achieved by traveling along about S a distance of theta from
%initial T=I

Stheta=S*theta;
[m,n]=size(Stheta);
if m~=6 || n~=1
    display('Input is not a 6-vector')
else
    wa=[Stheta(1); Stheta(2); Stheta(3)];
    w=[0 -wa(3) wa(2); wa(3) 0 -wa(1); -wa(2) wa(1) 0];
    v=[Stheta(4); Stheta(5); Stheta(6)];
    I=eye(3);
    theta=norm(wa);
    T=[I+sin(theta)*w+(1-cos(theta))*w^2 (I*theta+(1-cos(theta))*w+(theta-sin(theta))*w^2)*v; 0 0 0 1];
end
end