function [r]=MatrixLog3(R)
%function [r]=MatrixLog3(R)
%takes R in SO(3) and returns corresponding 3-vector of exponential
%coordinates r=w*theta

[m,n]=size(R);
A=isequal(R,eye(3));
if m~=3 || n~=3
    display('Input is not a 3x3 matrix')
elseif A~=0
        r=[0;0;0];
elseif trace(R)==-1
    theta=pi;
    w1=1/sqrt(2*(1+R(3,3)))*[R(1,3);R(2,3);1+R(3,3)];
    w2=1/sqrt(2*(1+R(2,3)))*[R(1,3);1+R(2,3);R(3,3)];
    w3=1/sqrt(2*(1+R(1,3)))*[1+R(1,3);R(2,3);R(3,3)];
    w1=w1(~isnan(w1));
    w2=w2(~isnan(w2));
    w3=w3(~isnan(w3));
    if length(w1)~=3
        if length(w2)~=3
            w=w3;
        else w=w2;
        end
    else w=w1;
    end
r=w*theta;
else
	theta=acos((trace(R)-1)/2);
	w=(R-R')/(2*sin(theta));
    if theta==0
        r=[0;0;0];
    else
    end
end


end