function [S]=ScrewToAxis(q,s,h)
%given point q in R3, unit axis s in R3, and screw pitch h in R, returns
%corresponding screw axis [w,v], a normalized spatial velocity in the same
%frame as q and s

[m,n]=size(q);
theta=norm(s);
if m~=3 || n~=1
    display('The input point is not a point in R3')
else
    if theta~=1
        display('The input axis is not a unit axis')
    else
        if size(h)~=1
            display('The input pitch is not an element of R')
        else
            w=s;
            v=-cross(s,q)+h*s;
            S=[w;v];
        end
    end
end
end
