function [R,p]=TransToRp(T);
%function [R,p]=TransToRp(T);
%Takes transformation "T" and gives back rotation matrix "R" in SO(3) and
%position vector p in R3

[m,n]=size(T);
if m~=4 || n~=4
    display('The input is not a 4x4 matrix')
else
    if T(4,1)~=0 || T(4,2)~=0 || T(4,3)~=0 || T(4,4)~=1
        display('The input is not a Transformation matrix')
    else
        R=[T(1,1) T(1,2) T(1,3); T(2,1) T(2,2) T(2,3); T(3,1) T(3,2) T(3,3)];
        p=[T(1,4) T(2,4) T(3,4)];
        %error using horzcat
        %Dimensions of matrices being concatenated are not consistent.
end
end
